Exception.InnerException Exception.InnerException Exception.InnerException Exception.InnerException Property

Определение

Возвращает экземпляр класса Exception, который вызвал текущее исключение.Gets the Exception instance that caused the current exception.

public:
 property Exception ^ InnerException { Exception ^ get(); };
public Exception InnerException { get; }
member this.InnerException : Exception
Public ReadOnly Property InnerException As Exception

Значение свойства

Объект, описывающий ошибку, которая вызвала текущее исключение.An object that describes the error that caused the current exception. Свойство InnerException возвращает то же значение, что было передано в конструктор Exception(String, Exception) , или значение null , если конструктору не было передано значение внутреннего исключения.The InnerException property returns the same value as was passed into the Exception(String, Exception) constructor, or null if the inner exception value was not supplied to the constructor. Это свойство доступно только для чтения.This property is read-only.

Реализации

Примеры

В следующем примере демонстрируется создание и перехват исключения, ссылающегося на внутреннее исключение.The following example demonstrates throwing and catching an exception that references an inner exception.

using namespace System;

public ref class AppException: public Exception
{
public:
   AppException(String^ message ) : Exception(message)
   {}

   AppException(String^ message, Exception^ inner) : Exception(message, inner)
   {}
};

public ref class Example
{
public:
   void ThrowInner()
   {
      throw gcnew AppException("Exception in ThrowInner method.");
   }

   void CatchInner()
   {
      try {
         this->ThrowInner();
      }
      catch (AppException^ e) {
         throw gcnew AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
};

int main()
{
   Example^ ex = gcnew Example();
   try {
      ex->CatchInner();
   }
   catch (AppException^ e) {
      Console::WriteLine("In catch block of Main method.");
      Console::WriteLine("Caught: {0}", e->Message);
      if (e->InnerException != nullptr)
         Console::WriteLine("Inner exception: {0}", e->InnerException);
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.CatchInner()
using System;

public class AppException : Exception
{
   public AppException(String message) : base (message)
   {}

   public AppException(String message, Exception inner) : base(message,inner) {}
}

public class Example
{
   public static void Main()
   {
      Example ex = new Example();

      try {
         ex.CatchInner();
      }
      catch(AppException e) {
         Console.WriteLine ("In catch block of Main method.");
         Console.WriteLine("Caught: {0}", e.Message);
         if (e.InnerException != null)
            Console.WriteLine("Inner exception: {0}", e.InnerException);
      }
   }

   public void ThrowInner ()
   {
      throw new AppException("Exception in ThrowInner method.");
   }

   public void CatchInner() 
   {
      try {
         this.ThrowInner();
      }
      catch (AppException e) {
         throw new AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.CatchInner()
Public Class AppException : Inherits Exception
   Public Sub New(message As String)
      MyBase.New(message)
   End Sub
   
   Public Sub New(message As String, inner As Exception)
      MyBase.New(message, inner)
   End Sub
End Class

Public Class Example
   Public Shared Sub Main()
      Dim testInstance As New Example()
      Try
         testInstance.CatchInner()
      Catch e As AppException
         Console.WriteLine ("In catch block of Main method.")
         Console.WriteLine("Caught: {0}", e.Message)
         If e.InnerException IsNot Nothing Then
            Console.WriteLine("Inner exception: {0}", e.InnerException)
         End If
      End Try
   End Sub
   
   Public Sub ThrowInner()
      Throw New AppException("Exception in ThrowInner method.")
   End Sub
   
   Public Sub CatchInner()
      Try
         Me.ThrowInner()
      Catch e As AppException
         Throw New AppException("Error in CatchInner caused by calling the ThrowInner method.", e)
      End Try
   End Sub
End Class
' The example displays the following output:
'    In catch block of Main method.
'    Caught: Error in CatchInner caused by calling the ThrowInner method.
'    Inner exception: AppException: Exception in ThrowInner method.
'       at Example.CatchInner()

Комментарии

Если X исключение создается как прямой результат предыдущего исключения Y, InnerException свойство объекта X должно содержать ссылку на Y.When an exception X is thrown as a direct result of a previous exception Y, the InnerException property of X should contain a reference to Y.

Свойство InnerException используется, чтобы получить набор исключений, ставших причиной текущего исключения.Use the InnerException property to obtain the set of exceptions that led to the current exception.

Можно создать новое исключение, которое перехватывает предыдущее исключение.You can create a new exception that catches an earlier exception. Код, обрабатывающий второе исключение, может использовать дополнительные сведения из предыдущего исключения для более адекватной обработки ошибки.The code that handles the second exception can make use of the additional information from the earlier exception to handle the error more appropriately.

Предположим, что имеется функция, которая считывает файл и форматирует данные из этого файла.Suppose that there is a function that reads a file and formats the data from that file. В этом примере, когда код пытается прочитать файл, IOException создается исключение.In this example, as the code tries to read the file, an IOException is thrown. Функция перехватывает IOException и FileNotFoundExceptionсоздает исключение.The function catches the IOException and throws a FileNotFoundException. Можно сохранить FileNotFoundExceptionв свойстве, включив код, который перехватывает объект FileNotFoundException , чтобы проверить причину первоначальной ошибки. InnerException IOExceptionThe IOException could be saved in the InnerException property of the FileNotFoundException, enabling the code that catches the FileNotFoundException to examine the cause of the initial error.

InnerException Свойство, содержащее ссылку на внутреннее исключение, задается при инициализации объекта исключения.The InnerException property, which holds a reference to the inner exception, is set upon initialization of the exception object.

Применяется к